/*----- PROTECTED REGION ID(EbsCorrectorClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        EbsCorrectorClass.h
//
// description : Include for the EbsCorrector root class.
//               This class is the singleton class for
//                the EbsCorrector device class.
//               It contains all properties and methods which the 
//               EbsCorrector requires only once e.g. the commands.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
// Copyright (C): 2022
//                European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                France
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef EbsCorrectorClass_H
#define EbsCorrectorClass_H

#include <tango.h>
#include <EbsCorrector.h>


/*----- PROTECTED REGION END -----*/	//	EbsCorrectorClass.h


namespace EbsCorrector_ns
{
/*----- PROTECTED REGION ID(EbsCorrectorClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	EbsCorrectorClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Strength class definition
class StrengthAttrib: public Tango::Attr
{
public:
	StrengthAttrib():Attr("Strength",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~StrengthAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<EbsCorrector *>(dev))->read_Strength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<EbsCorrector *>(dev))->write_Strength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<EbsCorrector *>(dev))->is_Strength_allowed(ty);}
};

//	Attribute Frozen class definition
class FrozenAttrib: public Tango::Attr
{
public:
	FrozenAttrib():Attr("Frozen",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~FrozenAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<EbsCorrector *>(dev))->read_Frozen(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<EbsCorrector *>(dev))->write_Frozen(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<EbsCorrector *>(dev))->is_Frozen_allowed(ty);}
};


//=========================================
//	Define classes for dynamic attributes
//=========================================
//	Attribute CorrectionStrength class definition
class CorrectionStrengthAttrib: public Tango::Attr
{
public:
	CorrectionStrengthAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~CorrectionStrengthAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<EbsCorrector *>(dev))->read_CorrectionStrength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<EbsCorrector *>(dev))->write_CorrectionStrength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<EbsCorrector *>(dev))->is_CorrectionStrength_allowed(ty);}
};

//	Attribute ResonanceStrength class definition
class ResonanceStrengthAttrib: public Tango::Attr
{
public:
	ResonanceStrengthAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~ResonanceStrengthAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<EbsCorrector *>(dev))->read_ResonanceStrength(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<EbsCorrector *>(dev))->write_ResonanceStrength(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<EbsCorrector *>(dev))->is_ResonanceStrength_allowed(ty);}
};

//	Attribute Current class definition
class CurrentAttrib: public Tango::Attr
{
public:
	CurrentAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~CurrentAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<EbsCorrector *>(dev))->read_Current(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<EbsCorrector *>(dev))->write_Current(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<EbsCorrector *>(dev))->is_Current_allowed(ty);}
};

//	Attribute SetCurrentsAverage class definition
class SetCurrentsAverageAttrib: public Tango::Attr
{
public:
	SetCurrentsAverageAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_DOUBLE, Tango::READ) {};
	~SetCurrentsAverageAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<EbsCorrector *>(dev))->read_SetCurrentsAverage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<EbsCorrector *>(dev))->is_SetCurrentsAverage_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command SetpointCheck class definition
class SetpointCheckClass : public Tango::Command
{
public:
	SetpointCheckClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SetpointCheckClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SetpointCheckClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<EbsCorrector *>(dev))->is_SetpointCheck_allowed(any);}
};

//	Command Reset class definition
class ResetClass : public Tango::Command
{
public:
	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ResetClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<EbsCorrector *>(dev))->is_Reset_allowed(any);}
};


//=========================================
//	Define classes for dynamic commands
//=========================================
//	Command ResetResonanceStrength class definition
class ResetResonanceStrengthClass : public Tango::Command
{
public:
	ResetResonanceStrengthClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ResetResonanceStrengthClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ResetResonanceStrengthClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<EbsCorrector *>(dev))->is_ResetResonanceStrength_allowed(any);}
};


/**
 *	The EbsCorrectorClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  EbsCorrectorClass : public Tango::DeviceClass
#else
class EbsCorrectorClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(EbsCorrectorClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	EbsCorrectorClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static EbsCorrectorClass *init(const char *);
		static EbsCorrectorClass *instance();
		~EbsCorrectorClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		EbsCorrectorClass(string &);
		static EbsCorrectorClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	EbsCorrector_H
