/*----- PROTECTED REGION ID(EbsCorrectorStateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        EbsCorrectorStateMachine.cpp
//
// description : State machine file for the EbsCorrector class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
// Copyright (C): 2022
//                European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                France
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <EbsCorrector.h>

/*----- PROTECTED REGION END -----*/	//	EbsCorrector::EbsCorrectorStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================


namespace EbsCorrector_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : EbsCorrector::is_Strength_allowed()
 *	Description : Execution allowed for Strength attribute
 */
//--------------------------------------------------------
bool EbsCorrector::is_Strength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Strength attribute in Write access.
	/*----- PROTECTED REGION ID(EbsCorrector::StrengthStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsCorrector::StrengthStateAllowed_WRITE

	//	Not any excluded states for Strength attribute in read access.
	/*----- PROTECTED REGION ID(EbsCorrector::StrengthStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsCorrector::StrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsCorrector::is_Frozen_allowed()
 *	Description : Execution allowed for Frozen attribute
 */
//--------------------------------------------------------
bool EbsCorrector::is_Frozen_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Frozen attribute in Write access.
	/*----- PROTECTED REGION ID(EbsCorrector::FrozenStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsCorrector::FrozenStateAllowed_WRITE

	//	Not any excluded states for Frozen attribute in read access.
	/*----- PROTECTED REGION ID(EbsCorrector::FrozenStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsCorrector::FrozenStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsCorrector::is_CorrectionStrength_allowed()
 *	Description : Execution allowed for CorrectionStrength attribute
 */
//--------------------------------------------------------
bool EbsCorrector::is_CorrectionStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CorrectionStrength attribute in Write access.
	/*----- PROTECTED REGION ID(EbsCorrector::CorrectionStrengthStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsCorrector::CorrectionStrengthStateAllowed_WRITE

	//	Not any excluded states for CorrectionStrength attribute in read access.
	/*----- PROTECTED REGION ID(EbsCorrector::CorrectionStrengthStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsCorrector::CorrectionStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsCorrector::is_ResonanceStrength_allowed()
 *	Description : Execution allowed for ResonanceStrength attribute
 */
//--------------------------------------------------------
bool EbsCorrector::is_ResonanceStrength_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for ResonanceStrength attribute in Write access.
	/*----- PROTECTED REGION ID(EbsCorrector::ResonanceStrengthStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsCorrector::ResonanceStrengthStateAllowed_WRITE

	//	Not any excluded states for ResonanceStrength attribute in read access.
	/*----- PROTECTED REGION ID(EbsCorrector::ResonanceStrengthStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsCorrector::ResonanceStrengthStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsCorrector::is_Current_allowed()
 *	Description : Execution allowed for Current attribute
 */
//--------------------------------------------------------
bool EbsCorrector::is_Current_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Current attribute in Write access.
	/*----- PROTECTED REGION ID(EbsCorrector::CurrentStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsCorrector::CurrentStateAllowed_WRITE

	//	Not any excluded states for Current attribute in read access.
	/*----- PROTECTED REGION ID(EbsCorrector::CurrentStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsCorrector::CurrentStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsCorrector::is_SetCurrentsAverage_allowed()
 *	Description : Execution allowed for SetCurrentsAverage attribute
 */
//--------------------------------------------------------
bool EbsCorrector::is_SetCurrentsAverage_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for SetCurrentsAverage attribute in read access.
	/*----- PROTECTED REGION ID(EbsCorrector::SetCurrentsAverageStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsCorrector::SetCurrentsAverageStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : EbsCorrector::is_SetpointCheck_allowed()
 *	Description : Execution allowed for SetpointCheck attribute
 */
//--------------------------------------------------------
bool EbsCorrector::is_SetpointCheck_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for SetpointCheck command.
	/*----- PROTECTED REGION ID(EbsCorrector::SetpointCheckStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsCorrector::SetpointCheckStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsCorrector::is_Reset_allowed()
 *	Description : Execution allowed for Reset attribute
 */
//--------------------------------------------------------
bool EbsCorrector::is_Reset_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Reset command.
	/*----- PROTECTED REGION ID(EbsCorrector::ResetStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsCorrector::ResetStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsCorrector::is_ResetResonanceStrength_allowed()
 *	Description : Execution allowed for ResetResonanceStrength attribute
 */
//--------------------------------------------------------
bool EbsCorrector::is_ResetResonanceStrength_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ResetResonanceStrength command.
	/*----- PROTECTED REGION ID(EbsCorrector::ResetResonanceStrengthStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsCorrector::ResetResonanceStrengthStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(EbsCorrector::EbsCorrectorStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	EbsCorrector::EbsCorrectorStateAllowed.AdditionalMethods

}	//	End of namespace
