/*----- PROTECTED REGION ID(EbsMagnetStateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        EbsMagnetStateMachine.cpp
//
// description : State machine file for the EbsMagnet class
//
// project :     EbsMagnet
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
// Copyright (C): 2022
//                European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                France
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <EbsMagnet.h>

/*----- PROTECTED REGION END -----*/	//	EbsMagnet::EbsMagnetStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================


namespace EbsMagnet_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_SerialNumber_allowed()
 *	Description : Execution allowed for SerialNumber attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_SerialNumber_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for SerialNumber attribute in read access.
	/*----- PROTECTED REGION ID(EbsMagnet::SerialNumberStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::SerialNumberStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_CorrectorState_allowed()
 *	Description : Execution allowed for CorrectorState attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_CorrectorState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for CorrectorState attribute in read access.
	/*----- PROTECTED REGION ID(EbsMagnet::CorrectorStateStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::CorrectorStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_RequireCycling_allowed()
 *	Description : Execution allowed for RequireCycling attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_RequireCycling_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for RequireCycling attribute in read access.
	/*----- PROTECTED REGION ID(EbsMagnet::RequireCyclingStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::RequireCyclingStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_Currents_allowed()
 *	Description : Execution allowed for Currents attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_Currents_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Currents attribute in Write access.
	/*----- PROTECTED REGION ID(EbsMagnet::CurrentsStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::CurrentsStateAllowed_WRITE

	//	Not any excluded states for Currents attribute in read access.
	/*----- PROTECTED REGION ID(EbsMagnet::CurrentsStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::CurrentsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_Strengths_allowed()
 *	Description : Execution allowed for Strengths attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_Strengths_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for Strengths attribute in Write access.
	/*----- PROTECTED REGION ID(EbsMagnet::StrengthsStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::StrengthsStateAllowed_WRITE

	//	Not any excluded states for Strengths attribute in read access.
	/*----- PROTECTED REGION ID(EbsMagnet::StrengthsStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::StrengthsStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_Reset_allowed()
 *	Description : Execution allowed for Reset attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_Reset_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Reset command.
	/*----- PROTECTED REGION ID(EbsMagnet::ResetStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::ResetStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_SetDesignStrength_allowed()
 *	Description : Execution allowed for SetDesignStrength attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_SetDesignStrength_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for SetDesignStrength command.
	/*----- PROTECTED REGION ID(EbsMagnet::SetDesignStrengthStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::SetDesignStrengthStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_ApplyDeltaStrength_allowed()
 *	Description : Execution allowed for ApplyDeltaStrength attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_ApplyDeltaStrength_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ApplyDeltaStrength command.
	/*----- PROTECTED REGION ID(EbsMagnet::ApplyDeltaStrengthStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::ApplyDeltaStrengthStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_ResetResonanceStrength_allowed()
 *	Description : Execution allowed for ResetResonanceStrength attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_ResetResonanceStrength_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ResetResonanceStrength command.
	/*----- PROTECTED REGION ID(EbsMagnet::ResetResonanceStrengthStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::ResetResonanceStrengthStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_MainCurrentSetpointCheck_allowed()
 *	Description : Execution allowed for MainCurrentSetpointCheck attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_MainCurrentSetpointCheck_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for MainCurrentSetpointCheck command.
	/*----- PROTECTED REGION ID(EbsMagnet::MainCurrentSetpointCheckStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::MainCurrentSetpointCheckStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_On_allowed()
 *	Description : Execution allowed for On attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_On_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for On command.
	/*----- PROTECTED REGION ID(EbsMagnet::OnStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::OnStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_Off_allowed()
 *	Description : Execution allowed for Off attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_Off_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Off command.
	/*----- PROTECTED REGION ID(EbsMagnet::OffStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::OffStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_GetACPSCurrent_allowed()
 *	Description : Execution allowed for GetACPSCurrent attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_GetACPSCurrent_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetACPSCurrent command.
	/*----- PROTECTED REGION ID(EbsMagnet::GetACPSCurrentStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::GetACPSCurrentStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_GetPSCurrent_allowed()
 *	Description : Execution allowed for GetPSCurrent attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_GetPSCurrent_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetPSCurrent command.
	/*----- PROTECTED REGION ID(EbsMagnet::GetPSCurrentStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::GetPSCurrentStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_WritePSCurrent_allowed()
 *	Description : Execution allowed for WritePSCurrent attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_WritePSCurrent_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for WritePSCurrent command.
	/*----- PROTECTED REGION ID(EbsMagnet::WritePSCurrentStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::WritePSCurrentStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_Cycle_allowed()
 *	Description : Execution allowed for Cycle attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_Cycle_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Cycle command.
	/*----- PROTECTED REGION ID(EbsMagnet::CycleStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::CycleStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_Swap_allowed()
 *	Description : Execution allowed for Swap attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_Swap_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Swap command.
	/*----- PROTECTED REGION ID(EbsMagnet::SwapStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::SwapStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : EbsMagnet::is_Unswap_allowed()
 *	Description : Execution allowed for Unswap attribute
 */
//--------------------------------------------------------
bool EbsMagnet::is_Unswap_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Unswap command.
	/*----- PROTECTED REGION ID(EbsMagnet::UnswapStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	EbsMagnet::UnswapStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(EbsMagnet::EbsMagnetStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	EbsMagnet::EbsMagnetStateAllowed.AdditionalMethods

}	//	End of namespace
